# -*- coding: utf-8 -*-
import numpy as np
import matplotlib.pyplot as plt

def f(x):
    return np.sum(x, axis=1)**2

def mcquad(f, d, N):
    """Berechnet das `d`-dimensionale Integral von `f`.

    Input:
        f : Funktion welche integriert werden soll. Das Argument von
            `f` ist ein (N,d)-Array.
        d : Anzahl Dimensionen.
        N : Anzahl Zufallsvektoren.
    """
    # TODO implementieren Sie dies.

    mean = 0.0
    sigma = 0.0
    return mean, sigma

def repeated_mc_quad(f, d, n_samples, n_rep):
    """Ruft `mcquad` wiederholt auf und berechnet Statistic.

    Input:
        n_rep : Die `mcquad(f, d, n_samples)` Experimente werden
                `n_rep` mal ausgeführt.

    Output:
           I_mc : Mittelwert der Experimente.
          means : Wert der einzelnen Experimente.
        sigma_M : Standardabweichung der Experimente.
    """

    means = np.empty(n_rep)

    # TODO implementieren Sie dies.

    I_mc = 0.0
    sigma_M = 1.0

    return I_mc, means, sigma_M

def savefig(base_filename):
    plt.savefig(base_filename + ".pdf")
    plt.savefig(base_filename + ".png")

def ex3_b():
    # TODO lösen Sie aufgabe 3 b)
    # Die exakte Lösung ist
    #     I_exact = d/3.0 + 0.25*d*(d - 1)
    pass


def ex3_c():
    # TODO lösen Sie Aufgabe 3 c)
    pass

def convergence_rate(n, err):
    """Berechnet die Konvergenzordnung.

    Input:
         n : Anzahl MC-Samples.
       err : Der mittlere Fehler.
    """
    poly = np.polyfit(np.log(n), np.log(err), deg=1)
    return poly[0]

def ex3_d():
    # TODO lösen Sie Aufgabe 3 d)
    pass

if __name__ == "__main__":
    ex3_b()
    ex3_c()
    ex3_d()
